/*
 * \file port.h
 *
 * \date Mar 4, 2017
 * \author Ting
 */

#ifndef PORT_H_
#define PORT_H_

#include "derivative.h"
#include "util.h"

#define ePORTA_PCR0		(unsigned int volatile *)0x40049000	
#define ePORTA_PCR1		(unsigned int volatile *)0x40049004	
#define ePORTA_PCR2		(unsigned int volatile *)0x40049008	
#define ePORTA_PCR3		(unsigned int volatile *)0x4004900c	
#define ePORTA_PCR4		(unsigned int volatile *)0x40049010	
#define ePORTA_PCR5		(unsigned int volatile *)0x40049014	
#define ePORTA_PCR6		(unsigned int volatile *)0x40049018	
#define ePORTA_PCR7		(unsigned int volatile *)0x4004901c	
#define ePORTA_PCR8		(unsigned int volatile *)0x40049020	
#define ePORTA_PCR9		(unsigned int volatile *)0x40049024	
#define ePORTA_PCR10	(unsigned int volatile *)0x40049028	
#define ePORTA_PCR11	(unsigned int volatile *)0x4004902c	
#define ePORTA_PCR12	(unsigned int volatile *)0x40049030	
#define ePORTA_PCR13	(unsigned int volatile *)0x40049034	
#define ePORTA_PCR14	(unsigned int volatile *)0x40049038	
#define ePORTA_PCR15	(unsigned int volatile *)0x4004903c	
#define ePORTA_PCR16	(unsigned int volatile *)0x40049040	
#define ePORTA_PCR17	(unsigned int volatile *)0x40049044	
#define ePORTA_PCR18	(unsigned int volatile *)0x40049048	
#define ePORTA_PCR19	(unsigned int volatile *)0x4004904c	
#define ePORTA_PCR20	(unsigned int volatile *)0x40049050	
#define ePORTA_PCR21	(unsigned int volatile *)0x40049054	
#define ePORTA_PCR22	(unsigned int volatile *)0x40049058	
#define ePORTA_PCR23	(unsigned int volatile *)0x4004905c	
#define ePORTA_PCR24	(unsigned int volatile *)0x40049060	
#define ePORTA_PCR25	(unsigned int volatile *)0x40049064	
#define ePORTA_PCR26	(unsigned int volatile *)0x40049068	
#define ePORTA_PCR27	(unsigned int volatile *)0x4004906c	
#define ePORTA_PCR28	(unsigned int volatile *)0x40049070	
#define ePORTA_PCR29	(unsigned int volatile *)0x40049074	
#define ePORTA_PCR30	(unsigned int volatile *)0x40049078	
#define ePORTA_PCR31	(unsigned int volatile *)0x4004907c	

#define ePORTB_PCR0	(unsigned int volatile *)0x4004a000	
#define ePORTB_PCR1	(unsigned int volatile *)0x4004a004	
#define ePORTB_PCR2	(unsigned int volatile *)0x4004a008	
#define ePORTB_PCR3	(unsigned int volatile *)0x4004a00c	
#define ePORTB_PCR4	(unsigned int volatile *)0x4004a010	
#define ePORTB_PCR5	(unsigned int volatile *)0x4004a014	
#define ePORTB_PCR6	(unsigned int volatile *)0x4004a018	
#define ePORTB_PCR7	(unsigned int volatile *)0x4004a01c	
#define ePORTB_PCR8	(unsigned int volatile *)0x4004a020	
#define ePORTB_PCR9	(unsigned int volatile *)0x4004a024	
#define ePORTB_PCR10	(unsigned int volatile *)0x4004a028	
#define ePORTB_PCR11	(unsigned int volatile *)0x4004a02c	
#define ePORTB_PCR12	(unsigned int volatile *)0x4004a030	
#define ePORTB_PCR13	(unsigned int volatile *)0x4004a034	
#define ePORTB_PCR14	(unsigned int volatile *)0x4004a038	
#define ePORTB_PCR15	(unsigned int volatile *)0x4004a03c	
#define ePORTB_PCR16	(unsigned int volatile *)0x4004a040	
#define ePORTB_PCR17	(unsigned int volatile *)0x4004a044	
#define ePORTB_PCR18	(unsigned int volatile *)0x4004a048	
#define ePORTB_PCR19	(unsigned int volatile *)0x4004a04c	
#define ePORTB_PCR20	(unsigned int volatile *)0x4004a050	
#define ePORTB_PCR21	(unsigned int volatile *)0x4004a054	
#define ePORTB_PCR22	(unsigned int volatile *)0x4004a058	
#define ePORTB_PCR23	(unsigned int volatile *)0x4004a05c	
#define ePORTB_PCR24	(unsigned int volatile *)0x4004a060	
#define ePORTB_PCR25	(unsigned int volatile *)0x4004a064	
#define ePORTB_PCR26	(unsigned int volatile *)0x4004a068	
#define ePORTB_PCR27	(unsigned int volatile *)0x4004a06c	
#define ePORTB_PCR28	(unsigned int volatile *)0x4004a070	
#define ePORTB_PCR29	(unsigned int volatile *)0x4004a074	
#define ePORTB_PCR30	(unsigned int volatile *)0x4004a078	
#define ePORTB_PCR31	(unsigned int volatile *)0x4004a07c	

#define ePORTC_PCR0	(unsigned int volatile *)0x4004b000	
#define ePORTC_PCR1	(unsigned int volatile *)0x4004b004	
#define ePORTC_PCR2	(unsigned int volatile *)0x4004b008	
#define ePORTC_PCR3	(unsigned int volatile *)0x4004b00c	
#define ePORTC_PCR4	(unsigned int volatile *)0x4004b010	
#define ePORTC_PCR5	(unsigned int volatile *)0x4004b014	
#define ePORTC_PCR6	(unsigned int volatile *)0x4004b018	
#define ePORTC_PCR7	(unsigned int volatile *)0x4004b01c	
#define ePORTC_PCR8	(unsigned int volatile *)0x4004b020	
#define ePORTC_PCR9	(unsigned int volatile *)0x4004b024	
#define ePORTC_PCR10	(unsigned int volatile *)0x4004b028	
#define ePORTC_PCR11	(unsigned int volatile *)0x4004b02c	
#define ePORTC_PCR12	(unsigned int volatile *)0x4004b030	
#define ePORTC_PCR13	(unsigned int volatile *)0x4004b034	
#define ePORTC_PCR14	(unsigned int volatile *)0x4004b038	
#define ePORTC_PCR15	(unsigned int volatile *)0x4004b03c	
#define ePORTC_PCR16	(unsigned int volatile *)0x4004b040	
#define ePORTC_PCR17	(unsigned int volatile *)0x4004b044	
#define ePORTC_PCR18	(unsigned int volatile *)0x4004b048	
#define ePORTC_PCR19	(unsigned int volatile *)0x4004b04c	
#define ePORTC_PCR20	(unsigned int volatile *)0x4004b050	
#define ePORTC_PCR21	(unsigned int volatile *)0x4004b054	
#define ePORTC_PCR22	(unsigned int volatile *)0x4004b058	
#define ePORTC_PCR23	(unsigned int volatile *)0x4004b05c	
#define ePORTC_PCR24	(unsigned int volatile *)0x4004b060	
#define ePORTC_PCR25	(unsigned int volatile *)0x4004b064	
#define ePORTC_PCR26	(unsigned int volatile *)0x4004b068	
#define ePORTC_PCR27	(unsigned int volatile *)0x4004b06c	
#define ePORTC_PCR28	(unsigned int volatile *)0x4004b070	
#define ePORTC_PCR29	(unsigned int volatile *)0x4004b074	
#define ePORTC_PCR30	(unsigned int volatile *)0x4004b078	
#define ePORTC_PCR31	(unsigned int volatile *)0x4004b07c	

#define ePORTD_PCR0	(unsigned int volatile *)0x4004c000	
#define ePORTD_PCR1	(unsigned int volatile *)0x4004c004	
#define ePORTD_PCR2	(unsigned int volatile *)0x4004c008	
#define ePORTD_PCR3	(unsigned int volatile *)0x4004c00c	
#define ePORTD_PCR4	(unsigned int volatile *)0x4004c010	
#define ePORTD_PCR5	(unsigned int volatile *)0x4004c014	
#define ePORTD_PCR6	(unsigned int volatile *)0x4004c018	
#define ePORTD_PCR7	(unsigned int volatile *)0x4004c01c	
#define ePORTD_PCR8	(unsigned int volatile *)0x4004c020	
#define ePORTD_PCR9	(unsigned int volatile *)0x4004c024	
#define ePORTD_PCR10	(unsigned int volatile *)0x4004c028	
#define ePORTD_PCR11	(unsigned int volatile *)0x4004c02c	
#define ePORTD_PCR12	(unsigned int volatile *)0x4004c030	
#define ePORTD_PCR13	(unsigned int volatile *)0x4004c034	
#define ePORTD_PCR14	(unsigned int volatile *)0x4004c038	
#define ePORTD_PCR15	(unsigned int volatile *)0x4004c03c	
#define ePORTD_PCR16	(unsigned int volatile *)0x4004c040	
#define ePORTD_PCR17	(unsigned int volatile *)0x4004c044	
#define ePORTD_PCR18	(unsigned int volatile *)0x4004c048	
#define ePORTD_PCR19	(unsigned int volatile *)0x4004c04c	
#define ePORTD_PCR20	(unsigned int volatile *)0x4004c050	
#define ePORTD_PCR21	(unsigned int volatile *)0x4004c054	
#define ePORTD_PCR22	(unsigned int volatile *)0x4004c058	
#define ePORTD_PCR23	(unsigned int volatile *)0x4004c05c	
#define ePORTD_PCR24	(unsigned int volatile *)0x4004c060	
#define ePORTD_PCR25	(unsigned int volatile *)0x4004c064	
#define ePORTD_PCR26	(unsigned int volatile *)0x4004c068	
#define ePORTD_PCR27	(unsigned int volatile *)0x4004c06c	
#define ePORTD_PCR28	(unsigned int volatile *)0x4004c070	
#define ePORTD_PCR29	(unsigned int volatile *)0x4004c074	
#define ePORTD_PCR30	(unsigned int volatile *)0x4004c078	
#define ePORTD_PCR31	(unsigned int volatile *)0x4004c07c	

#define ePORTE_PCR0	(unsigned int volatile *)0x4004d000	
#define ePORTE_PCR1	(unsigned int volatile *)0x4004d004	
#define ePORTE_PCR2	(unsigned int volatile *)0x4004d008	
#define ePORTE_PCR3	(unsigned int volatile *)0x4004d00c	
#define ePORTE_PCR4	(unsigned int volatile *)0x4004d010	
#define ePORTE_PCR5	(unsigned int volatile *)0x4004d014	
#define ePORTE_PCR6	(unsigned int volatile *)0x4004d018	
#define ePORTE_PCR7	(unsigned int volatile *)0x4004d01c	
#define ePORTE_PCR8	(unsigned int volatile *)0x4004d020	
#define ePORTE_PCR9	(unsigned int volatile *)0x4004d024	
#define ePORTE_PCR10	(unsigned int volatile *)0x4004d028	
#define ePORTE_PCR11	(unsigned int volatile *)0x4004d02c	
#define ePORTE_PCR12	(unsigned int volatile *)0x4004d030	
#define ePORTE_PCR13	(unsigned int volatile *)0x4004d034	
#define ePORTE_PCR14	(unsigned int volatile *)0x4004d038	
#define ePORTE_PCR15	(unsigned int volatile *)0x4004d03c	
#define ePORTE_PCR16	(unsigned int volatile *)0x4004d040	
#define ePORTE_PCR17	(unsigned int volatile *)0x4004d044	
#define ePORTE_PCR18	(unsigned int volatile *)0x4004d048	
#define ePORTE_PCR19	(unsigned int volatile *)0x4004d04c	
#define ePORTE_PCR20	(unsigned int volatile *)0x4004d050	
#define ePORTE_PCR21	(unsigned int volatile *)0x4004d054	
#define ePORTE_PCR22	(unsigned int volatile *)0x4004d058	
#define ePORTE_PCR23	(unsigned int volatile *)0x4004d05c	
#define ePORTE_PCR24	(unsigned int volatile *)0x4004d060	
#define ePORTE_PCR25	(unsigned int volatile *)0x4004d064	
#define ePORTE_PCR26	(unsigned int volatile *)0x4004d068	
#define ePORTE_PCR27	(unsigned int volatile *)0x4004d06c	
#define ePORTE_PCR28	(unsigned int volatile *)0x4004d070	
#define ePORTE_PCR29	(unsigned int volatile *)0x4004d074	
#define ePORTE_PCR30	(unsigned int volatile *)0x4004d078	
#define ePORTE_PCR31	(unsigned int volatile *)0x4004d07c	

/*
 * Enumera&ccedil&atilde;o das portas do microcontrolador
 */
typedef enum _tipo_port {
	A,   /*!< A */
	B,   /*!< B */
	C,   /*!< C */
	D,   /*!< D */
	E    /*!< E */
} porta;

void initPort (porta p);

void setaMux(unsigned int volatile *reg, uint8_t mux);

void resetaMux(unsigned int volatile *reg);
#endif /* PORT_H_ */
